tic
clc;
close all;
clear all;

del_t=86400;
J=1.907*10^(-5);

Cw=4186;
Ki=2.24;
sigma=5.67*10^(-8);
rho_w=1000;
ci=2108;
rho_i=rho_w;
Lf=3.34*10^(5);
Melt=0;
XX=0;
load dem1.dat;
[p,q]=size(dem1);
dem=dem1;
T_wate=zeros(2,p,q);
T_wate_2=zeros(2,p,q);
virt_flag_2=zeros(p,q);
T_wat=(273.16+1)*ones(1,2);
% T_wat(2)=273.16;
T_wat_2=(273.16+1)*ones(1,2);
% T_wat_2(2)=273.16;
H_l=zeros(p,q);
H_i=zeros(p,q);
%H_t_i=zeros(1,94);
%H_t_l=zeros(1,94);
T_s_ice=zeros(p,q);
H_w=zeros(p,q);
Melt_top=zeros(p,q);

ice_flag=zeros(p,q);
del_ice_bel=zeros(p,q);
top_melt=zeros(p,q);
lake_bel=zeros(p,q);
virt_lid=zeros(p,q);
virt_lid_2=zeros(p,q);
virt_flag_1=zeros(p,q);

melt=0;
virt_lid_flag=0;
virt_lid_flag_2=0;
T_s_i=0;
H_lake=0;
H_ice=0;
melt_all=0;
add_water=0;
del_h_bel=0;
ice_melt_top=0;
del_h_ice_bel=0;
del_I=0;
del_I1=0;
H_wat=0;
count=zeros(p,q);
count1=zeros(p,q);
tempor=1;
x=dlmread('Lake_depth304.dat');
x1=reshape(x,[928,880]);
x1=x1';
scal=1;
scal1=1;

for k=180:2192
    [SWR,RH,U,V,cc,T,M,M1]=data_prep_lake(k);
    T=T+273.16;
    for i=444
        for j=284
            
            %   Water added into the lake pixel
            
            add_water=M(i,j)-M1(i,j);
            if add_water<0
                add_water=0;
            end
            if ice_flag(i,j)==0
                if count(i,j)==0 && M(i,j)>=0.1
                    H_lake=M(i,j);
                    del_I=virt_lid(i,j);
                end
                if count(i,j)>0
                    T_wat=T_wate(:,i,j);
                    H_lake=H_l(i,j);                    
                    del_I=virt_lid(i,j);
                    virt_lid_flag=virt_flag_1(i,j);
                end
            else
                T_wat=T_wate(:,i,j);
                H_lake=H_l(i,j);
                H_ice=H_i(i,j);
                T_s_i=T_s_ice(i,j);                
            end
            if dem(i,j)>0
                h_alt=dem(i,j);
                
                %   If only water exists (No permanent ice lid)
                
                if ice_flag(i,j)==0
                    %   Assigning values from previous timestep to the respective variables 
                    
                    H_lake=H_lake+add_water;                 
                    
%                     %   Estimating the SWR that is absorbed on the surface
%         
                    alb=(9702+1000*exp(3.6*H_lake))/(-539+20000*exp(3.6*H_lake));
                    SWR_in=SWR(i,j)*(1-alb);
                    
                    %   Melt below lake (Lake development)
                    
                    if T_wat(2)>273.16 && H_lake>=0.1
                        T1=-((del_t*Ki)/(rho_i*Lf))*((273.16-T_wat(2))/(H_lake/scal));
                        T2=sign(-273.16+T_wat(2))*((Cw*rho_w*del_t*J)/(rho_i*Lf))*(abs(-273.16+T_wat(2)))^(4/3);

                        del_h_bel=T1+T2;
                        if del_h_bel>0
                            H_lake=H_lake+del_h_bel;
                        else
                            del_h_bel=0;
                            H_lake=H_lake+del_h_bel;
                        end
                    end
                    
                    %   Energy balance of the lake (water only)
                    
                    if virt_lid_flag==0     %   No virtual lid formation

                        [T_wat,H_lake,q]=water_only_new(T_wat,SWR_in,cc(i,j),T(i,j),U(i,j),V(i,j),h_alt,RH(i,j),H_lake);

                        if T_wat(1)<273.16
                            T_s_i=T_wat(1);
                            virt_lid_flag=1;
                            T_wat(1)=273.16;
                        end
                    end
                    if virt_lid_flag>0
                        T_wat(1)=273.16;
                    end
                    I0=0.6;
                    if H_lake>=0.1 && T_wat(2)>273.16
                        A=rho_w*Cw*J*sign(T_wat(2)-T_wat(1))*(abs(T_wat(2)-T_wat(1)))^(4/3);
                        B=rho_w*Cw*J*sign(T_wat(2)-273.16)*(abs(T_wat(2)-273.16))^(4/3);
                        C=I0*SWR_in*(exp(-0.025*H_lake)-1);
                        T_wat(2)=T_wat(2)-((del_t*J)/(H_lake*rho_w*Cw))*(A+B+C);
                    else
                        T_wat(2)=273.16;
                    end                    
                    %   If surface temperature less than 273.16 K, ice lid
                    %   forms (Virtual lid)
                        
                     if virt_lid_flag>0      
                         SWR_n=SWR(i,j)*(1-alb);
                         [del_I,T_s_i,H_lake,virt_lid_flag]=refreeze(T_wat,SWR_n,cc(i,j),T(i,j),U(i,j),V(i,j),h_alt,RH(i,j),H_lake,del_I,virt_lid_flag,scal,T_s_i);
                     end
                     
                     if del_I>=0.1
                         H_ice=del_I;
                         del_I=0;
                         virt_lid_flag=0;
                         ice_flag(i,j)=1;
                     end
                     count(i,j)=count(i,j)+1;
                else
                    if add_water>0
                        H_lake=H_lake+add_water;
                    end 
                    
                    %   Estimating energy balance of the ice lid and the lake below
                    
                    [T_s_i,T_wat,H_lake,H_ice]=ice_water_new_3(H_lake,U(i,j),V(i,j),SWR(i,j),cc(i,j),RH(i,j),T(i,j),T_s_i,T_wat,h_alt,H_ice,k,scal);
                    
                    %   If the ice lid melts completely, ice flag for that pixel is set to zero
                    
                    if H_ice==0 || H_ice<0
                        ice_flag(i,j)=0;
                        T_s_i=273.16;
                        T_wat(1)=273.16;
                        H_ice=0;
                    end                    
                end
                T_wate(:,i,j)=T_wat;            %   Storing lake water temperature for next timestep
                H_l(i,j)=H_lake;                %   Storing lake height for next timestep
                H_i(i,j)=H_ice;                 %   Storing ice lid thickness for next timestep
                T_s_ice(i,j)=T_s_i;             %   Storing ice lid surface temperature for next timestep
                virt_lid(i,j)=del_I;
                virt_flag_1(i,j)=virt_lid_flag;
                disp(k);
                if del_I>0
                    disp(del_I);	
                else	
                    disp(H_ice);
                end
                disp(H_lake);
            else
                H_ice=H_ice+H_lake;
                H_lake=0;                
            end
        end
    end
    H_t_l(k)=H_lake;
    if del_I~=0
        H_t_i(k)=del_I;
    else
        H_t_i(k)=H_ice;
    end    
%     scal=max(1,(round(H_lake)));
%     scal=scal*scal;
     if H_lake==0 || H_lake<0.1  
            H_lake=0;
            break;
     end    
end
filename='water_depth_2.dat';
save(filename,'H_t_l','-ascii');

filename='ice_depth_2.dat';
save(filename,'H_t_i','-ascii');
toc